//-----------------------------------------------
//Global Variable Definitions
//-----------------------------------------------
volatile unsigned char curr_flag;
volatile unsigned char syn;
volatile unsigned long PHASE;
volatile unsigned long adc_old;
volatile unsigned char one_step;
volatile unsigned char harm_flag;
volatile unsigned char update;
volatile unsigned char key1_flag;
volatile unsigned char key2_flag;
volatile unsigned char key3_flag;
volatile unsigned char key_value;
volatile unsigned char speed_max;


short DISABLE_HARM_RED_FLAG = 0;
//-----------------------------------------------
//Constant Definitions
//-----------------------------------------------
#define update_rate 2
/*
#define INT0IF 0x02
#define INTEDGE0 0x40
#define INTEDGE0_L_TO_H 0x40    // 01000000
#define INTEDGE0_H_TO_L 0xBF    // 10111111

#define TMR0IF_OVERFLOW_YES 0x04
#define TMR0IF_OVERFLOW_NO 0xFB
#define TMR0IF_OVERFLOW_BIT 0x04

#define GLOBAL_INT_EN_BIT 0x80
#define GLOBAL_INT_DISABLE 0x7F
*/

//***************************************************************************
//* Functions
//***************************************************************************

void init(void);
void startupdelay (unsigned long degree, unsigned long cnt);
unsigned long phase2timer(unsigned long phase_value);
void KBI_ISR(void);
void T0_ISR(void);
void T1_ISR(void);

void fire_triac(void);
unsigned long get_speed(void);
unsigned long harm_reduce(unsigned long phase_value);

unsigned long get_ADC(void);
unsigned long softswitch(unsigned long adc_value);
void ccp_timer(void);
int test_ac();
